// DiskDlg.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "CrystalMark.h"
#include "CrystalMarkDlg.h"
#include "DiskDlg.h"

#include "Share.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

static CCrystalMarkDlg* P;
static void GetDiskSize(char *RootPath,double *FreeSize,double *UseSize,double *TotalSize,double *UsageRate);

/////////////////////////////////////////////////////////////////////////////
// CDiskDlg _CAO


CDiskDlg::CDiskDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDiskDlg::IDD, pParent)
{
	P = (CCrystalMarkDlg*)pParent;
	SysInfo = ((CCrystalMarkDlg*)pParent)->SysInfo;
	//{{AFX_DATA_INIT(CDiskDlg)
	m_DiskModel = _T("");
	m_DiskInterface = _T("");
	m_DiskDiskSize = _T("");
	m_DiskBufferSize = _T("");
	m_DiskLBA28 = _T("");
	m_DiskLBA48 = _T("");
	m_DiskSerialNumber = _T("");
	m_DiskRevision = _T("");
	m_DiskCHS = _T("");
	m_DiskATA = _T("");
	m_DiskCurrentMode = _T("");
	m_DiskMaxMode = _T("");
	//}}AFX_DATA_INIT
}


void CDiskDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDiskDlg)
	DDX_Control(pDX, IDC_DISK_SERIAL_NUMBER, m_DiskSerialNumberC);
	DDX_Control(pDX, IDC_DISK_REVISION, m_DiskRevisionC);
	DDX_Control(pDX, IDC_DISK_MAX_MODE, m_DiskMaxModeC);
	DDX_Control(pDX, IDC_DISK_LBA48, m_DiskLBA48C);
	DDX_Control(pDX, IDC_DISK_LBA28, m_DiskLBA28C);
	DDX_Control(pDX, IDC_DISK_INTERFACE, m_DiskInterfaceC);
	DDX_Control(pDX, IDC_DISK_DISK_SIZE, m_DiskDiskSizeC);
	DDX_Control(pDX, IDC_DISK_CURRENT_MODE, m_DiskCurrentModeC);
	DDX_Control(pDX, IDC_DISK_CHS, m_DiskCHSC);
	DDX_Control(pDX, IDC_DISK_BUFFER_SIZE, m_DiskBufferSizeC);
	DDX_Control(pDX, IDC_DISK_ATA, m_DiskATAC);
	DDX_Control(pDX, IDC_DISK_MODEL, m_DiskModelC);
	DDX_Control(pDX, IDC_DISK_DRIVE_LIST, m_DiskDriveList);
	DDX_Control(pDX, IDC_DISK_LIST, m_DiskList);
	DDX_Text(pDX, IDC_DISK_MODEL, m_DiskModel);
	DDX_Text(pDX, IDC_DISK_INTERFACE, m_DiskInterface);
	DDX_Text(pDX, IDC_DISK_DISK_SIZE, m_DiskDiskSize);
	DDX_Text(pDX, IDC_DISK_BUFFER_SIZE, m_DiskBufferSize);
	DDX_Text(pDX, IDC_DISK_LBA28, m_DiskLBA28);
	DDX_Text(pDX, IDC_DISK_LBA48, m_DiskLBA48);
	DDX_Text(pDX, IDC_DISK_SERIAL_NUMBER, m_DiskSerialNumber);
	DDX_Text(pDX, IDC_DISK_REVISION, m_DiskRevision);
	DDX_Text(pDX, IDC_DISK_CHS, m_DiskCHS);
	DDX_Text(pDX, IDC_DISK_ATA, m_DiskATA);
	DDX_Text(pDX, IDC_DISK_CURRENT_MODE, m_DiskCurrentMode);
	DDX_Text(pDX, IDC_DISK_MAX_MODE, m_DiskMaxMode);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDiskDlg, CDialog)
	//{{AFX_MSG_MAP(CDiskDlg)
	ON_NOTIFY(NM_CLICK, IDC_DISK_LIST, OnClickDiskList)
	ON_WM_CTLCOLOR()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDiskDlg bZ[W nh

BOOL CDiskDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

	int i;
	CString cstr;
// Xgr[̍\z
	LVCOLUMN myColumn;
	myColumn.mask = LVCF_TEXT | LVCF_WIDTH | LVCF_ORDER ;
	char str[5120];	// 80x64
	// Rg[̕擾
	CRect cr;m_DiskList.GetClientRect(cr);
	DWORD width = cr.Width() - GetSystemMetrics(SM_CXVSCROLL);

	// Xgr[̊gX^CKp
	double comctl32 = GetFileVersion("comctl32.dll");
	if( comctl32 >= 470 ){
		long dwStyle;
		dwStyle = ListView_GetExtendedListViewStyle(m_DiskList.m_hWnd);
		dwStyle |=	LVS_EX_FULLROWSELECT | LVS_EX_GRIDLINES;
		ListView_SetExtendedListViewStyle(m_DiskList.m_hWnd, dwStyle);
		dwStyle = ListView_GetExtendedListViewStyle(m_DiskDriveList.m_hWnd);
		dwStyle |=	LVS_EX_FULLROWSELECT | LVS_EX_GRIDLINES;
		ListView_SetExtendedListViewStyle(m_DiskDriveList.m_hWnd, dwStyle);
	}

	if( comctl32 >= 471 ){
		m_DiskList.GetHeaderCtrl()->EnableWindow(FALSE);
		m_DiskDriveList.GetHeaderCtrl()->EnableWindow(FALSE);		
	}
	m_DiskList.InsertColumn(0,"Model",LVCFMT_LEFT,width * 9 / 20,0);
	m_DiskList.InsertColumn(1,"Interface",LVCFMT_CENTER,width * 3 / 20,0);
	m_DiskList.InsertColumn(2,"Disk Size [GB]",LVCFMT_CENTER,width * 4/ 20,0);
	m_DiskList.InsertColumn(3,"Buffer Size [KB]",LVCFMT_CENTER,width * 4 / 20,0);
	m_DiskList.InsertColumn(4,"CHS",LVCFMT_CENTER,0,0);
	m_DiskList.InsertColumn(5,"LBA28",LVCFMT_CENTER,0,0);
	m_DiskList.InsertColumn(6,"LBA48",LVCFMT_CENTER,0,0);
	m_DiskList.InsertColumn(7,"Serial Number",LVCFMT_CENTER,0,0);
	m_DiskList.InsertColumn(8,"Revision",LVCFMT_CENTER,0,0);
	m_DiskList.InsertColumn(9,"ATA",LVCFMT_CENTER,0,0);
	m_DiskList.InsertColumn(10,"MaxMode",LVCFMT_CENTER,0,0);
	m_DiskList.InsertColumn(11,"CurrentMode",LVCFMT_CENTER,0,0);
	m_DiskList.InsertColumn(12,"Data",LVCFMT_CENTER,0,0);
/*
	m_DiskList.InsertColumn(12,"Data1",LVCFMT_CENTER,0,0);
	m_DiskList.InsertColumn(13,"Data2",LVCFMT_CENTER,0,0);
	m_DiskList.InsertColumn(14,"Data3",LVCFMT_CENTER,0,0);
	m_DiskList.InsertColumn(15,"Data4",LVCFMT_CENTER,0,0);
	m_DiskList.InsertColumn(16,"Data5",LVCFMT_CENTER,0,0);
	m_DiskList.InsertColumn(17,"Data6",LVCFMT_CENTER,0,0);
	m_DiskList.InsertColumn(18,"Data7",LVCFMT_CENTER,0,0);
	m_DiskList.InsertColumn(19,"Data8",LVCFMT_CENTER,0,0);
	m_DiskList.InsertColumn(20,"Data9",LVCFMT_CENTER,0,0);
	m_DiskList.InsertColumn(21,"Data10",LVCFMT_CENTER,0,0);
	m_DiskList.InsertColumn(22,"Data11",LVCFMT_CENTER,0,0);
	m_DiskList.InsertColumn(23,"Data12",LVCFMT_CENTER,0,0);
	m_DiskList.InsertColumn(24,"Data13",LVCFMT_CENTER,0,0);
	m_DiskList.InsertColumn(25,"Data14",LVCFMT_CENTER,0,0);
	m_DiskList.InsertColumn(26,"Data15",LVCFMT_CENTER,0,0);
	m_DiskList.InsertColumn(27,"Data16",LVCFMT_CENTER,0,0);
*/
	LVITEM myItem;
	memset(&myItem,0,sizeof(LVITEM));
	myItem.mask = LVIF_TEXT;
	if( ! (CheckSafeMode() & MODE_SAFE) ){
		DebugInfo(IDE_INIT_START);

		CHddInfo* hddinfo = new CHddInfo;
		hddinfo->getHardDriveComputerID();
		CINFO *hdd;
		// HDD List ɒǉ
		for(i = 0;i < hddinfo->m_alpInfo.GetSize();i++){
			hdd = hddinfo->m_alpInfo.GetAt(i);
			//  Serial ATA ɂ͖Ή
//			if( hdd->m_strDriveMaxMode.Find("Serial") == -1 ){
				myItem.iItem = i;
				myItem.iSubItem = 0;sprintf(str,"%s",hdd->m_strDriveModel);myItem.pszText = str;m_DiskList.InsertItem(&myItem);
				myItem.iSubItem = 1;
				if( hdd->m_strDriveMaxMode.Find("SATA") == -1 ){
					sprintf(str,"%s","IDE");
				}else{
					sprintf(str,"%s","SATA");
				}
				myItem.pszText = str;m_DiskList.SetItem(&myItem);
				myItem.iSubItem = 2;sprintf(str,"%0.1f",hdd->m_nDriveDiskSize / 10.0);myItem.pszText = str;m_DiskList.SetItem(&myItem);
				myItem.iSubItem = 3;
				if(hdd->m_nDriveBufferSize != 0){
					sprintf(str,"%d",hdd->m_nDriveBufferSize/1024);
				}else{
					sprintf(str,"");
				}
				myItem.pszText = str;
				m_DiskList.SetItem(&myItem);

				myItem.iSubItem = 4;sprintf(str,"%0.1f",hdd->m_nDriveDiskSizeCHS / 10.0);myItem.pszText = str;m_DiskList.SetItem(&myItem);
				myItem.iSubItem = 5;sprintf(str,"%0.1f",hdd->m_nDriveDiskSize28 / 10.0);myItem.pszText = str;m_DiskList.SetItem(&myItem);
				myItem.iSubItem = 6;sprintf(str,"%0.1f",hdd->m_nDriveDiskSize48 / 10.0);myItem.pszText = str;m_DiskList.SetItem(&myItem);
				myItem.iSubItem = 7;sprintf(str,"%s",hdd->m_strDriveSerial);myItem.pszText = str;m_DiskList.SetItem(&myItem);
				myItem.iSubItem = 8;sprintf(str,"%s",hdd->m_strCtrlRev);myItem.pszText = str;m_DiskList.SetItem(&myItem);
				myItem.iSubItem = 9;sprintf(str,"%s",hdd->m_strDriveATA);myItem.pszText = str;m_DiskList.SetItem(&myItem);
				myItem.iSubItem =10;sprintf(str,"%s",hdd->m_strDriveMaxMode);myItem.pszText = str;m_DiskList.SetItem(&myItem);
				myItem.iSubItem =11;sprintf(str,"%s",hdd->m_strDriveCurrentMode);myItem.pszText = str;m_DiskList.SetItem(&myItem);
				myItem.iSubItem =12;
				sprintf(str,"%s",hdd->m_strData);
				myItem.pszText = str;
				m_DiskList.SetItem(&myItem);

/*				for(int j=0;j<16;j++){
					myItem.iSubItem =12 + j;sprintf(str,"%s",hdd->m_strData[j]);myItem.pszText = str;m_DiskList.SetItem(&myItem);
//					MessageBox(str);
				}
//			}
*/
		}
		delete hddinfo;
		DebugInfo(IDE_INIT_END);
	}

	Internationalise();
	m_NumberOfItem = m_DiskList.GetItemCount();
	SetDiskDetailInfo(0);
	m_DiskList.SetItemState(0, LVIS_SELECTED|LVIS_FOCUSED,LVIS_SELECTED|LVIS_FOCUSED );

	return TRUE;
}

void CDiskDlg::OnClickDiskList(NMHDR* pNMHDR, LRESULT* pResult) 
{
	//NbNW擾
	DWORD dwPos = ::GetMessagePos();
	CPoint point ((int)LOWORD(dwPos),(int)HIWORD(dwPos));
	m_DiskList.ScreenToClient(&point);

	m_hotItem = m_DiskList.HitTest(point);
	SetDiskDetailInfo(m_hotItem);
	*pResult = 0;
}

void CDiskDlg::SetDiskDetailInfo(DWORD hotItem)
{
	if(0 <= hotItem && hotItem < m_NumberOfItem){ 
		CString cstr;
		m_DiskModel = " " + m_DiskList.GetItemText(hotItem,0);
		m_DiskInterface = m_DiskList.GetItemText(hotItem,1);
		m_DiskDiskSize = m_DiskList.GetItemText(hotItem,2);
		m_DiskBufferSize = m_DiskList.GetItemText(hotItem,3);
		m_DiskCHS = m_DiskList.GetItemText(hotItem,4);
		m_DiskLBA28 = m_DiskList.GetItemText(hotItem,5);
		m_DiskLBA48 = m_DiskList.GetItemText(hotItem,6);
		m_DiskSerialNumber = " " + m_DiskList.GetItemText(hotItem,7);
		m_DiskRevision = m_DiskList.GetItemText(hotItem,8);
		m_DiskATA = " " + m_DiskList.GetItemText(hotItem,9);
		m_DiskMaxMode = m_DiskList.GetItemText(hotItem,10);
		m_DiskCurrentMode = m_DiskList.GetItemText(hotItem,11);

		m_DiskList.SetSelectionMark(hotItem);
		UpdateData(FALSE);

		if( gFlagBack ){
			m_DiskModelC.ShowWindow(SW_HIDE);
			m_DiskModelC.ShowWindow(SW_SHOW);
			m_DiskInterfaceC.ShowWindow(SW_HIDE);
			m_DiskInterfaceC.ShowWindow(SW_SHOW);
			m_DiskDiskSizeC.ShowWindow(SW_HIDE);
			m_DiskDiskSizeC.ShowWindow(SW_SHOW);
			m_DiskBufferSizeC.ShowWindow(SW_HIDE);
			m_DiskBufferSizeC.ShowWindow(SW_SHOW);
			m_DiskCHSC.ShowWindow(SW_HIDE);
			m_DiskCHSC.ShowWindow(SW_SHOW);
			m_DiskLBA28C.ShowWindow(SW_HIDE);
			m_DiskLBA28C.ShowWindow(SW_SHOW);
			m_DiskLBA48C.ShowWindow(SW_HIDE);
			m_DiskLBA48C.ShowWindow(SW_SHOW);
			m_DiskSerialNumberC.ShowWindow(SW_HIDE);
			m_DiskSerialNumberC.ShowWindow(SW_SHOW);
			m_DiskRevisionC.ShowWindow(SW_HIDE);
			m_DiskRevisionC.ShowWindow(SW_SHOW);
			m_DiskATAC.ShowWindow(SW_HIDE);
			m_DiskATAC.ShowWindow(SW_SHOW);
			m_DiskMaxModeC.ShowWindow(SW_HIDE);
			m_DiskMaxModeC.ShowWindow(SW_SHOW);
			m_DiskCurrentModeC.ShowWindow(SW_HIDE);
			m_DiskCurrentModeC.ShowWindow(SW_SHOW);
		}
	}
}

void CDiskDlg::Internationalise()
{
	m_DiskDriveList.DeleteAllItems();
	int i=0;
	while(m_DiskDriveList.DeleteColumn(0)){}

	// Rg[̕擾
	CRect cr;m_DiskDriveList.GetClientRect(cr);
	DWORD width = cr.Width() - GetSystemMetrics(SM_CXVSCROLL);
	LVITEM myItem;memset(&myItem,0,sizeof(LVITEM));
	myItem.mask = LVIF_TEXT;

	if( gLanguage == ENGLISH ){
		m_DiskDriveList.InsertColumn(0,"",LVCFMT_LEFT,0,0);
		m_DiskDriveList.InsertColumn(1,"",LVCFMT_CENTER,width / 20,0);
		m_DiskDriveList.InsertColumn(2,"Type",LVCFMT_LEFT,width * 6 / 20,0);
		m_DiskDriveList.InsertColumn(3,"Free [GB]",LVCFMT_CENTER,width * 3 / 20,0);
		m_DiskDriveList.InsertColumn(4,"Used [GB]",LVCFMT_CENTER,width * 3 / 20,0);
		m_DiskDriveList.InsertColumn(5,"Size [GB]",LVCFMT_CENTER,width * 3 / 20,0);
		m_DiskDriveList.InsertColumn(6,"Usage Rate [%]",LVCFMT_CENTER,width * 4 / 20,0);
	}else{
		m_DiskDriveList.InsertColumn(0,"",LVCFMT_LEFT,0,0);
		m_DiskDriveList.InsertColumn(1,"",LVCFMT_CENTER,width / 20,0);
		m_DiskDriveList.InsertColumn(2,"^Cv",LVCFMT_LEFT,width * 6 / 20,0);
		m_DiskDriveList.InsertColumn(3,"󂫗e [GB]",LVCFMT_CENTER,width * 3 / 20,0);
		m_DiskDriveList.InsertColumn(4,"gp [GB]",LVCFMT_CENTER,width * 3 / 20,0);
		m_DiskDriveList.InsertColumn(5,"TCY [GB]",LVCFMT_CENTER,width * 3 / 20,0);
		m_DiskDriveList.InsertColumn(6,"gp [%]",LVCFMT_CENTER,width * 4 / 20,0);
	}
	//char str[256];
	char szDrives[128];char* pDrive;
	GetLogicalDriveStrings( sizeof(szDrives), szDrives );
	pDrive = szDrives;i=0;
	while( *pDrive )
	{
		CString Drive,DriveType,DriveFree,DriveUse,DriveSize,DriveUsageRate;
		int result = GetDriveType(pDrive);
		int forward = strlen( pDrive );
		pDrive[1] = '\0';
		_strupr(pDrive);// 啶ɕϊ
		Drive = pDrive;
		double FreeSize;
		double UseSize;
		double TotalSize;
		double UsageRate;

		char RootPath[4];char FileSystem[32];
		RootPath[0] = pDrive[0];RootPath[1] = ':';RootPath[2] = '\\';RootPath[3] = '\0';
		if(result == DRIVE_FIXED){
			if(gLanguage == ENGLISH){DriveType = "Hard Disk";}
			else{DriveType = "n[hfBXN";}
			GetVolumeInformation(RootPath,NULL,NULL,NULL,NULL,NULL,FileSystem,sizeof(FileSystem));
			DriveType += " [ ";DriveType += FileSystem;DriveType += " ]";
			GetDiskSize(RootPath,&FreeSize,&UseSize,&TotalSize,&UsageRate);
			DriveFree.Format("%.2f",FreeSize);
			DriveUse.Format("%.2f",UseSize);
			DriveSize.Format("%.2f",TotalSize);
			DriveUsageRate.Format("%.2f",UsageRate);
		}else if(result == DRIVE_CDROM){
			if(gLanguage == ENGLISH){DriveType = "CD/DVD Drive";}
			else{DriveType = "CD/DVD hCu";}
		}else if(result == DRIVE_REMOTE){
			if(gLanguage == ENGLISH){DriveType = "Network Drive";}
			else{DriveType = "lbg[NhCu";}
		}else if(result == DRIVE_REMOVABLE){
			if(gLanguage == ENGLISH){DriveType = "Removable Drive";}
			else{DriveType = "[ouhCu";}
		}else if(result == DRIVE_RAMDISK){
			if(gLanguage == ENGLISH){DriveType = "RAM Drive";}
			else{DriveType = "RAM hCu";}
		}else{
			if(gLanguage == ENGLISH){DriveType = "Unknown";}
			else{DriveType = "s";}
		}

		myItem.iItem = i;
		myItem.iSubItem = 0;myItem.pszText = "";m_DiskDriveList.InsertItem(&myItem);
		myItem.iSubItem = 1;myItem.pszText = (char *)(const char *)Drive;m_DiskDriveList.SetItem(&myItem);
		myItem.iSubItem = 2;myItem.pszText = (char *)(const char *)DriveType;m_DiskDriveList.SetItem(&myItem);
		myItem.iSubItem = 3;myItem.pszText = (char *)(const char *)DriveFree;m_DiskDriveList.SetItem(&myItem);
		myItem.iSubItem = 4;myItem.pszText = (char *)(const char *)DriveUse;m_DiskDriveList.SetItem(&myItem);
		myItem.iSubItem = 5;myItem.pszText = (char *)(const char *)DriveSize;m_DiskDriveList.SetItem(&myItem);
		myItem.iSubItem = 6;myItem.pszText = (char *)(const char *)DriveUsageRate;m_DiskDriveList.SetItem(&myItem);
		i++;
		pDrive += forward + 1;
	}
}

static void GetDiskSize(char *RootPath,double *FreeSize,double *UseSize,double *TotalSize,double *UsageRate)
{
	// hCű󂫗eʂmF //
	OSVERSIONINFO osVersionInfo;
	osVersionInfo.dwOSVersionInfoSize=sizeof(OSVERSIONINFO);
	GetVersionEx(&osVersionInfo);
	// Windows95 hm[} 
	if(osVersionInfo.dwPlatformId == VER_PLATFORM_WIN32_WINDOWS && LOWORD(osVersionInfo.dwBuildNumber) < 1000){
		DWORD SectorsPerCluster,BytesPerSectors,NumberOfFreeClusters,TotalNumberOfClusters;
		GetDiskFreeSpace(RootPath,&SectorsPerCluster,&BytesPerSectors,&NumberOfFreeClusters,&TotalNumberOfClusters);
		*FreeSize = SectorsPerCluster * BytesPerSectors * NumberOfFreeClusters / 1024.0 / 1024 / 1024;
		*TotalSize = SectorsPerCluster * BytesPerSectors * TotalNumberOfClusters / 1024.0 / 1024 / 1024;
		*UseSize = *TotalSize - *FreeSize;
		*UsageRate = *UseSize / *TotalSize * 100.0;
	}else{	// Windows95 ̏^ȊO GetDiskFreeSpaceEx g
		BOOL (WINAPI *GetDiskFreeSpaceEX)(LPCTSTR,PULARGE_INTEGER,PULARGE_INTEGER,PULARGE_INTEGER);
		ULARGE_INTEGER FreeBytesAvailableToCaller,TotalNumberOfBytes,TotalNumberOfFreeBytes;
		GetDiskFreeSpaceEX = (BOOL (WINAPI *)(LPCTSTR,PULARGE_INTEGER,PULARGE_INTEGER,PULARGE_INTEGER) )GetProcAddress(GetModuleHandle("kernel32.dll"),"GetDiskFreeSpaceExA");
		GetDiskFreeSpaceEX(RootPath,&FreeBytesAvailableToCaller,&TotalNumberOfBytes,&TotalNumberOfFreeBytes);
		*FreeSize = (double)(__int64)TotalNumberOfFreeBytes.QuadPart / 1024.0 / 1024 / 1024;
		*UseSize = (double)(__int64)TotalNumberOfBytes.QuadPart / 1024.0 / 1024 / 1024
				 - (double)(__int64)TotalNumberOfFreeBytes.QuadPart / 1024.0 / 1024 / 1024;
		*TotalSize = (double)(__int64)TotalNumberOfBytes.QuadPart / 1024.0 / 1024 / 1024;
		*UsageRate = *UseSize / *TotalSize * 100.0;
	}
}

HBRUSH CDiskDlg::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor) 
{
	HBRUSH hbr = CDialog::OnCtlColor(pDC, pWnd, nCtlColor);

	if( gFlagBack ){
		switch (nCtlColor)
		{
			case CTLCOLOR_STATIC:
			{
				pDC->SetTextColor(gTextColor);
				pDC->SetBkMode(TRANSPARENT);
				return (HBRUSH)GetStockObject(HOLLOW_BRUSH);
			}
			case CTLCOLOR_DLG:
			{
				return (HBRUSH)gBackBrush;
			}
		}
	}else{
		switch (nCtlColor)
		{
			case CTLCOLOR_STATIC:
			{
				pDC->SetTextColor(gTextColor);
				pDC->SetBkMode(TRANSPARENT);
			}
		}
	}

	return hbr;
}

void CDiskDlg::OnOK() 
{
//	CDialog::OnOK();
}

void CDiskDlg::OnCancel() 
{
//	CDialog::OnCancel();
}
