#include "stdafx.h"
#include "share.h"

#pragma comment(lib,"version.lib")

void WindowFlash(CWnd& Wnd)
{
	Wnd.ShowWindow(SW_HIDE);
	Wnd.ShowWindow(SW_SHOW);
}

typedef BOOL (WINAPI *LPFN_ISWOW64PROCESS) (HANDLE hProcess,PBOOL Wow64Process);

BOOL IsWow64(VOID)
{
	BOOL bIsWow64 = FALSE;
	LPFN_ISWOW64PROCESS fnIsWow64Process = (LPFN_ISWOW64PROCESS)GetProcAddress(GetModuleHandle("kernel32"),"IsWow64Process");
	if (NULL != fnIsWow64Process)
	{
		if (!fnIsWow64Process(GetCurrentProcess(),&bIsWow64))
		{
			// handle error
			bIsWow64 = FALSE;
		}
	}
	return bIsWow64;
}

DWORD CheckSafeMode()
{
	DWORD Mode=0;

	char path[MAX_PATH];
	char ini[MAX_PATH],str[256];char* ptrEnd;
	::GetModuleFileName(NULL, ini, MAX_PATH);
	if ( (ptrEnd = strrchr(ini, '.')) != NULL ){*ptrEnd = '\0';strcat(ini, ".ini");}

	GetPrivateProfileString("Setting","SafeMode","0",str,256,ini);
	if( atoi( str ) > 0 ){Mode = Mode | MODE_SAFE;}
	GetPrivateProfileString("Setting","PC-98Mode","0",str,256,ini);
	if( atoi( str ) > 0 ){Mode = Mode | MODE_PC98;}

	GetPrivateProfileString("Setting","DisableWMI","0",str,256,ini);
	if( atoi( str ) == 1 ){ Mode = Mode | MODE_WMI_OFF; }

	if(! IsWow64()){
		// WMI `FbN //
		GetSystemDirectory(path,MAX_PATH);
		strcat(path,"\\wbem\\wbemcore.dll");
		if( GetFileVersion(path) < 150 ){
			Mode = Mode | MODE_WMI_OFF;
		}
	}

	// hCu`FbN //
	char myapp[MAX_PATH];
	::GetModuleFileName(NULL, myapp, MAX_PATH);
	if(myapp[0] == '\\'){ // lbg[NhCűN
		Mode = Mode | MODE_SAFE;
	}else{
		wsprintf(str,"%C:\\",myapp[0]);
		if( GetDriveType(str) != DRIVE_FIXED ){
			Mode = Mode | MODE_SAFE;
		}
	}

	// A hCu HDD Ȃ PC-98x1 񂰂`Zvlł...
	//wsprintf(str,"A:\\");
	//if( GetDriveType(str) == DRIVE_FIXED ){
	if( IsPC98() ){
		Mode = Mode | MODE_PC98;
	}

	return Mode;
}

BOOL IsPC98()
{
    if(GetKeyboardType(0) != 7)return FALSE;
    return ((GetKeyboardType(1) & 0xff00) == 0x0d00);
}

int CheckWMIFlag(const char* check)
{
	DWORD Mode=0;

	char ini[MAX_PATH],str[256];char* ptrEnd;
	::GetModuleFileName(NULL, ini, MAX_PATH);
	if ( (ptrEnd = strrchr(ini, '.')) != NULL ){*ptrEnd = '\0';strcat(ini, ".ini");}

	GetPrivateProfileString("Setting",check,"0",str,256,ini);
	return atoi(str);
}


void DeviceNameList(char* file,CComboBox& combo)
{
	FILE* fp;
	char buf[1024];
	char check[1024];
	char *id;
	char *rev;
	char *name;
	char *token;

	char FileName[MAX_PATH];char* ptrEnd;
	::GetModuleFileName(NULL, FileName, MAX_PATH);
	if ( (ptrEnd = strrchr(FileName, '\\')) != NULL ){*ptrEnd = '\0';strcat(FileName,"\\");strcat(FileName, file);}

	strcpy(check,"");
	fp = fopen(FileName,"r");
	if(fp != NULL){
		while( fgets(buf,1024,fp) ){
			if(buf[0] == ';' || buf[0] == '\r' || buf[0] == '\n'){continue;}
			token = strtok( buf , ",\t\n" );	id    = token;
			token = strtok( NULL, ",\t\n" );	rev   = token;
			token = strtok( NULL, ",\t\n" );	name  = token;
			if(name != NULL && strcmp(check,name) != 0){
				strcpy(check,name);
				combo.AddString(name);
			}
		}
		fclose(fp);
	}
	//	MessageBox(id,name,MB_OK);
}

void LoadDataBase(CString FileName,CComboBox& ComboBox)
{
	ComboBox.ResetContent();

	CString data = "";
	const int BufferSize = 4096;
	char Buffer[BufferSize];
	DWORD BytesRead;
	DWORD length;
	HANDLE hFile;
	char *token;
	if( hFile = ::CreateFile(FileName,GENERIC_READ,0,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL) ){
		while ( ReadFile(hFile,Buffer,BufferSize,&BytesRead,NULL) && BytesRead !=0){
			if(BytesRead != BufferSize){
				Buffer[BytesRead] = '\0';
			}
			data += Buffer;
		}
		token = strtok((char *)(LPCTSTR)data , "\n");
		while(token != NULL){
			if( ( length = strlen(token) ) > 0){
				token[length - 1] = '\0'; // '\n' -> '\0'
				ComboBox.InsertString(-1,token);
				token = strtok( NULL , "\n");
			}
		}
		CloseHandle(hFile);
	}
}

void ChipSetList(char* file,CComboBox& combo)
{
	FILE* fp;
	char buf[1024];
	char check[1024];
	char *nid;
	char *sid;
	char *nrev;
	char *srev;
	char *name;
	char *token;

	char FileName[MAX_PATH];char* ptrEnd;
	::GetModuleFileName(NULL, FileName, MAX_PATH);
	if ( (ptrEnd = strrchr(FileName, '\\')) != NULL ){*ptrEnd = '\0';strcat(FileName,"\\");strcat(FileName, file);}

	fp = fopen(FileName,"r");
	if(fp != NULL){
		while( fgets(buf,1024,fp) ){
			if(buf[0] == ';' || buf[0] == '\r' || buf[0] == '\n'){continue;}
			token = strtok( buf , ",\t\n" );	nid   = token;
			token = strtok( NULL, ",\t\n" );	nrev  = token;
			token = strtok( NULL, ",\t\n" );	sid   = token;
			token = strtok( NULL, ",\t\n" );	srev  = token;
			token = strtok( NULL, ",\t\n" );	name  = token;
			if(name != NULL && strcmp(check,name) != 0){
				strcpy(check,name);
				combo.AddString(name);
			}
		}
		fclose(fp);
	}
	//MessageBox(NULL,"","",MB_OK);
}

int ExecAndWait(char *pszCmd, BOOL bNoWindow)
{
	DWORD Code;
	BOOL bSuccess;
	STARTUPINFO si;
	PROCESS_INFORMATION pi;

	memset(&si, 0, sizeof(STARTUPINFO));
	si.cb = sizeof(STARTUPINFO);

	if (bNoWindow) {
		si.dwFlags = STARTF_USESHOWWINDOW;
		si.wShowWindow = SW_HIDE;
	}
	bSuccess = CreateProcess(
		NULL,	// lpApplicationName
		pszCmd,	// lpCommandLine
		NULL,	// lpProcessAttributes
		NULL,	// lpThreadAttributes
		FALSE,	// bInheritHandle
		0,		// dwCreationFlag
		NULL,	// lpEnvironment
		NULL,	// lpCurrentDirectory
		&si,	// lpStartupInfo
		&pi		// lpProcessInformation
	);
	if (bSuccess != TRUE) return 0;

	WaitForInputIdle(pi.hProcess, INFINITE);
	WaitForSingleObject(pi.hProcess, INFINITE);

	GetExitCodeProcess(pi.hProcess, &Code);

	CloseHandle(pi.hThread);
	CloseHandle(pi.hProcess);

	return Code;
}

int HttpPostMethod(char* post,char *ServerName,char *ScriptPath,char *UserAgent)
{

	int result = ERROR_HTTP_OFF_LINE;

	_InternetOpen_ InternetOpen = NULL;
	_InternetConnect_ InternetConnect = NULL;
	_HttpOpenRequest_ HttpOpenRequest = NULL;
	_HttpSendRequest_ HttpSendRequest = NULL;
	_HttpQueryInfo_ HttpQueryInfo = NULL;
	_InternetCloseHandle_ InternetCloseHandle = NULL;

	HINSTANCE hDLL = LoadLibrary( "wininet.dll" );
	if( hDLL != NULL ){
		InternetOpen = (_InternetOpen_)GetProcAddress( hDLL, "InternetOpenA" );
		InternetConnect = (_InternetConnect_)GetProcAddress( hDLL, "InternetConnectA" );
		HttpOpenRequest = (_HttpOpenRequest_)GetProcAddress( hDLL, "HttpOpenRequestA" );
		HttpSendRequest = (_HttpSendRequest_)GetProcAddress( hDLL, "HttpSendRequestA" );
		HttpQueryInfo = (_HttpQueryInfo_)GetProcAddress( hDLL, "HttpQueryInfoA" );
		InternetCloseHandle = (_InternetCloseHandle_)GetProcAddress( hDLL, "InternetCloseHandle" );
	}else{
		return ERROR_HTTP_OFF_LINE;
	}

	if(InternetOpen != NULL){
		static char addheader[] = "Content-Type: application/x-www-form-urlencoded";
		HINTERNET hInternet = InternetOpen(UserAgent,INTERNET_OPEN_TYPE_PRECONFIG,NULL,NULL,0);
		if(hInternet != NULL){
			HINTERNET hSession = InternetConnect(hInternet,ServerName,INTERNET_DEFAULT_HTTP_PORT,NULL,NULL,INTERNET_SERVICE_HTTP,0,0);
			HINTERNET hHTTP = HttpOpenRequest(hSession,"POST",ScriptPath,NULL,NULL,0,INTERNET_FLAG_RELOAD,0);
			if( HttpSendRequest(hHTTP,addheader,strlen(addheader) + 1,post,strlen(post) + 1) ){
				char bufQuery[32];
				DWORD dwLengthBufQuery = sizeof(bufQuery);
				HttpQueryInfo(hHTTP,HTTP_QUERY_CONTENT_LENGTH ,bufQuery,&dwLengthBufQuery,0);
				result = atoi(bufQuery);
			}
			InternetCloseHandle(hHTTP);
			InternetCloseHandle(hSession);
			InternetCloseHandle(hInternet);
		}else{
			if( hDLL != NULL ){FreeLibrary(hDLL);}
			return ERROR_HTTP_OFF_LINE;
		}
	}else{
		if( hDLL != NULL ){FreeLibrary(hDLL);}
		return ERROR_HTTP_OFF_LINE;		
	}
	if( hDLL != NULL ){FreeLibrary(hDLL);}

	return result;
}

void ExecuteFile(char* FileName)
{
	char path[MAX_PATH],file[MAX_PATH];char* ptrEnd;
	::GetModuleFileName(NULL,path, MAX_PATH);
	if ( (ptrEnd = strrchr(path, '\\')) != NULL ){*ptrEnd = '\0';}
	sprintf(file,"%s\\%s",path,FileName);
	ShellExecute(NULL,NULL,file,NULL,NULL,SW_SHOWNORMAL);	
}

/*
FontSetting
0: None
1: Normal
2: CrearType 
*/
int FontSetting()
{
	unsigned long data;
	OSVERSIONINFO osVersionInfo;
	osVersionInfo.dwOSVersionInfoSize=sizeof(OSVERSIONINFO);
	GetVersionEx(&osVersionInfo);

	SystemParametersInfo(SPI_GETFONTSMOOTHING,0,&data,SPIF_SENDCHANGE);
	if(data > 0){data = 1;}
	if(data != 0 && osVersionInfo.dwPlatformId == VER_PLATFORM_WIN32_NT && osVersionInfo.dwBuildNumber >= 2600){
		HKEY hKey;
		unsigned long ulLength;
		unsigned long ulType=REG_DWORD;
		ulLength=sizeof(data);

		if( RegOpenKeyEx(HKEY_CURRENT_USER,"Control Panel\\Desktop",0, KEY_READ, &hKey) == ERROR_SUCCESS ){
			RegQueryValueEx(hKey,"FontSmoothingType",NULL,&ulType,(unsigned char *)&data,&ulLength);
			RegCloseKey(hKey);
		}
	}

	// Font Setting
	return data;
}

void GetFontStatus(CString& cstr)
{
	switch ( FontSetting() )
	{
	case 0:	cstr = "None";			break;
	case 1: cstr = "Normal";		break;
	case 2: cstr = "ClearType";		break;
	default:
		cstr = "Unknown";			break;
	}
}

void DebugInfo(char* mes)
{
	static int flag = TRUE;
	static char file[MAX_PATH];

//	MessageBox(NULL,mes,mes,MB_OK);

	if(flag){
		char* ptrEnd;
		::GetModuleFileName(NULL,file, MAX_PATH);
		if ( (ptrEnd = strrchr(file, '.')) != NULL ){*ptrEnd = '\0';strcat(file, ".log");}
		DeleteFile(file);
		flag = FALSE;
	}

	FILE *fp;
	fp = fopen(file,"a");
	fprintf(fp,"%s\n",mes);
	fclose(fp);

/*
	DWORD write;
	HANDLE hFile;
	hFile = CreateFile(file,GENERIC_WRITE,0,NULL,OPEN_ALWAYS,FILE_ATTRIBUTE_NORMAL|FILE_FLAG_WRITE_THROUGH,NULL);
	WriteFile(hFile,mes,strlen(mes),&write,NULL);
	WriteFile(hFile,"\r\n",2,&write,NULL);
	CloseHandle(hFile);
*/
}

BOOL SetAlphaWindow(HWND& hWnd,unsigned char alpha)
{
	BOOL result = FALSE;
	typedef BOOL (WINAPI *SetLayeredWindowAttributes) (HWND,COLORREF,BYTE,DWORD);
	HINSTANCE hLib = LoadLibrary("user32.dll");
	SetLayeredWindowAttributes pSetLayeredWindowAttributes = (SetLayeredWindowAttributes) GetProcAddress (hLib,"SetLayeredWindowAttributes");
	if( pSetLayeredWindowAttributes != NULL && alpha != 0 && alpha != 255 ){
		::SetWindowLong(hWnd,GWL_EXSTYLE,0x00080000); // WS_EX_LAYERED = 0x00080000
		::SetWindowPos(hWnd,HWND_TOP,0,0,0,0,SWP_NOMOVE | SWP_NOSIZE | SWP_NOZORDER | SWP_FRAMECHANGED);
		pSetLayeredWindowAttributes(
		  hWnd,
		  NULL,
		  alpha,//̒l0-255͈̔͂ŕύX܂!!
		  0x00000002 /* LWA_ALPHA */
		);
		result = TRUE;
	}
	FreeLibrary(hLib);

	return result;
}

BOOL IsWinNT()
{
	OSVERSIONINFO OSVersionInfo;
	OSVersionInfo.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);
	GetVersionEx(&OSVersionInfo);
	
	return OSVersionInfo.dwPlatformId == VER_PLATFORM_WIN32_NT;
}

void GetDisplayMode(int& width,int& height,int& color,int& font)
{
	HDC hDC = GetDC(NULL);
	width = GetDeviceCaps(hDC,HORZRES);
	height= GetDeviceCaps(hDC,VERTRES);
	color = GetDeviceCaps(hDC,BITSPIXEL);
	font  = FontSetting();
	ReleaseDC(NULL,hDC);
}